indexing
   description: "gdk event button"
   status: "You may be able to redistribute and/or modify this program.% 
          % ee the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_event_button.e,v 1.5 1999/01/18 19:54:55 pcj Exp $"

	 -- file created by Miron Brezuleanu

class GDK_EVENT_KEY
inherit 
   GDK_EVENT
      redefine
	 exg_create
      end
   GDK_KEYS
   
creation
   make, exg_create
feature -- Creation
   make is
      do
      end -- make
   exg_create (p : POINTER) is
      do
	 gdkobject := p 
      end
   
feature {ANY} -- Queries

   time: INTEGER is
      do
	 Result := ext_event_key_time(gdkobject)
      end

   state: INTEGER is
      do
	 Result := ext_event_key_state(gdkobject)
      end
   
   keyval: INTEGER is
      do
	 Result := ext_event_key_keyval(gdkobject)
      end
   
   keyval_as_string: STRING is
      do
	 Result := reverse_lookup(keyval)
      end

   shift_pressed: BOOLEAN is     	 
      do
	 Result := (state.to_bit and (1).to_bit).to_integer /= 0
      end

   ctrl_pressed: BOOLEAN is     	 
      do
	 Result := (state.to_bit and (4).to_bit).to_integer /= 0
      end

   meta_pressed: BOOLEAN is     	 
      do
	 Result := (state.to_bit and (8).to_bit).to_integer /= 0
      end	 

feature {NONE}
   
   ext_event_key_time(p: POINTER): INTEGER is
      external "C"
      end
   ext_event_key_state(p: POINTER): INTEGER is
      external "C"
      end
   ext_event_key_keyval(p: POINTER): INTEGER is
      external "C"
      end
invariant
end
