
class PGEN_PAGE_1

inherit
   WIZARD_PAGE
      rename
	 make as old_make
      end

creation
   make   

feature

   make(p: WIZARD_DATA) is
      local
	 separator: GTK_SEPARATOR
	 table: GTK_TABLE
	 label: GTK_LABEL
	 browse_button: GTK_BUTTON
      do
	 old_make(False, 0)
	 data := p
	 !!label.make_with_label(
				 "This is EXG. You are %
				 %using PGen to generate a %
				 %brand new application.%N %
				 %Please enter your application%'%
				 %s name and path.")
	 pack_start(label, False, False, 0)
	 label.show
	 !GTK_HSEPARATOR!separator.make
	 pack_start(separator, False, False, 0)
	 separator.show
	 !!table.make(2, 3, False)
	 !!label.make_with_label("Project name")
	 table.attach_defaults(label, 0, 1, 0, 1)
	 label.show
	 !!label.make_with_label("Project path")
	 table.attach_defaults(label, 0, 1, 1, 2)
	 label.show
	 !!project_name.make
	 table.attach_defaults(project_name, 1, 2, 0, 1)
	 project_name.show
	 !!project_path.make
	 table.attach_defaults(project_path, 1, 2, 1, 2)
	 project_path.show
	 !!browse_button.make_with_label("Browse")
	 table.attach_defaults(browse_button, 2, 3, 1, 2)
	 !!pp_command.make(Current)
	 browse_button.signal_connect("clicked", pp_command, Current)
	 browse_button.show
	 pack_start(table, False, False, 0)
	 table.show
      end

   project_name, project_path: GTK_ENTRY
   pp_command: PGEN_PAGE_1_COMMAND
   data: WIZARD_DATA
	 
   wizard_page_enter is
      do
      end

   wizard_page_leave is
      do
      end

   wizard_page_can_leave: BOOLEAN is
      local
	 m: EXG_MESSAGE_BOX
      do
	 if not equal(project_name.text, "") 
	    and not equal(project_name.text, "") then
	    Result := True
	 else
	    !!m.make
	    m.set_message("You must specify a name and a path for %
                          %your project!")
	    m.run
	 end
      end

   finish is
      do
	 data.set_project_name(project_name.text)
	 if not project_path.text.has_suffix("/") then
	    data.set_project_path(project_path.text + "/")
	 else
	    data.set_project_path(project_path.text)	 
	 end
      end

end
   
