
indexing
   author: "Miron Brezuleanu"
   purpose: "the edget that can encapsulate a GTK_BUTTON;"
   "when the button is pushed, it outputs a message containing the word"
   "%"click%""
   
class EE_BUTTON
   
inherit
   EE_EDGET
      rename
	 make as old_make
      end   
   GTK_COMMAND
   
creation   
   make
   
feature
   
   make(pname: STRING; pwidget: GTK_BUTTON) is
	 -- creates an edget with a name, associated with an already
	 -- created button (which preferably doesn't have any signals
	 -- connected)
      do
	 old_make(pname)
	 widget := pwidget
	 widget.signal_connect("clicked", Current, "")
      end
   
   execute(d: ANY) is
	 -- just outputs a message
      do
	 put("click")
      end
   
   run(content: ANY) is
	 -- ignores any input
      do
      end

end
