indexing
   author: "Miron Brezuleanu"
   purpose: "Wrap data for the cracking of the configure event"

class GDK_EVENT_CONFIGURE
   
inherit
   GDK_EVENT
      redefine
	 exg_create
      end

creation
   make, exg_create

feature -- Creation
   make is
      do
      end -- make
   exg_create (p : POINTER) is
      do
	 gdkobject := p 
      end
   
feature {ANY} -- Queries

   area: GDK_RECTANGLE is
	 -- returns the area which was configured
      do
	 !!Result.make(ext_event_configure_x(gdkobject),
		       ext_event_configure_y(gdkobject),
		       ext_event_configure_width(gdkobject),
		       ext_event_configure_height(gdkobject))
      end


feature {NONE}
   
   ext_event_configure_x(p: POINTER): INTEGER is
      external "C"
      end

   ext_event_configure_y(p: POINTER): INTEGER is
      external "C"
      end

   ext_event_configure_width(p: POINTER): INTEGER is
      external "C"
      end

   ext_event_configure_height(p: POINTER): INTEGER is
      external "C"
      end

end
