indexing
   description: "gdk object"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_object.e,v 1.6 1999/01/18 19:54:55 pcj Exp $"

deferred class GDK_OBJECT
   
inherit
   
   --creation
   --   exg_create
   
feature -- Creation     

   exg_create(new_gdkobject : POINTER) is
      require 
	 new_gdkobject /= default_pointer
      do
	 gdkobject := new_gdkobject
      end -- exg_create

   make_default is
      do
	 gdkobject := default_pointer
      end

feature {ANY} -- Queries

   to_external : POINTER is
      do
	 Result := gdkobject
      end   

feature {ANY} -- Commands

   -- modified by Miron Brezuleanu on 1999/05/20 - made gdkobject public
   -- because of VAPE restrictions

   gdkobject : POINTER -- the address of a gdk object

end -- GDK_OBJECT

