indexing
   description: "gtk requisition"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_requisition.e,v 1.8 1999/02/13 04:07:52 pcj Exp $"

class GTK_REQUISITION
   
inherit
   GTK_OBJECT   
      redefine
	 exg_create
      end

creation make, exg_create

feature -- Creation

   make ( width_, height_ : INTEGER ) is
      -- Creation and initialization
      do
	 !!storage.make(ext_sizeof_requisition); 
	 ext_requisition_new(width_, height_, storage.to_external); 
	 gtkobject := storage.to_external
      end -- make
   exg_create ( p : POINTER ) is
      do
	 gtkobject := p
      end

feature {ANY} -- Queries

feature {ANY} -- Commands
feature {GTK_WIDGET} 

feature {NONE}

   storage : FIXED_ARRAY[CHARACTER]

   ext_requisition_new ( w, h : INTEGER ; pstorage : POINTER ) is
      external "C"
      end

   ext_sizeof_requisition : INTEGER is
      external "C"
      end

invariant
end -- GTK_REQUISITION

