
indexing
   author: "Miron Brezuleanu"
   purpose: "wrap the behavior for canvases (drawing areas) that need %
            %to be larger than the allocated areas but also want to %
            %be centered in the allocated area if that is smaller"
	    
class EXG_SCROLLED_ALIGNED_CANVAS
   
inherit
   GTK_SCROLLED_WINDOW
      rename
	 make as old_make
      end
   
creation
   make
   
feature -- commands
   
   make (pcanvas: GTK_DRAWING_AREA) is
	 -- this will set up the canvas and the widgets wrapped 
	 -- around it
      do
	 old_make
	 canvas := pcanvas
	 !!alignment.make(0.5, 0.5, 0.0, 0.0)
	 alignment.add(canvas)
	 add_with_viewport(alignment)
	 set_policy(gtk_policy_automatic, gtk_policy_automatic)
	 canvas.show
	 alignment.show
      end
      
feature -- attributes & queries   
   
   canvas: GTK_DRAWING_AREA
   alignment: GTK_ALIGNMENT   
	 -- the widgets used to implement the requested behaviour
   
end
   
