
indexing
   author: "Miron Brezuleanu"
   purpose: "provides access to some time functions"
   
class EXG_TIME
   
feature -- commands
   
   read_time is
	 -- this will read the time and will fill the structs with 
	 -- reasonable values
      do
	 ext_read_time($second, $minute, $hour,
		       $day_of_week, $day_of_month, $day_of_year,
		       $month, $year)
      end
   
   random: STD_RAND is
	 -- this is good to have around
      once
	 read_time
	 !!Result.with_seed(hour * 3600 + minute * 60 + second
	                    + year + month)
      end
   
feature -- queries
   
   second, minute, hour: INTEGER
   day_of_week, day_of_month, day_of_year: INTEGER
   month, year: INTEGER
   
feature { NONE } -- external stuff   
   
   ext_read_time(p1, p2, p3, p4, p5, p6, p7, p8: POINTER) is
      external "C"
      end
   
end
